> For the complete documentation index, see [llms.txt](https://docs.cometh.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.cometh.io/integrations/react-hooks/usesignmessage.md).

# useSignMessage

## Description

This hook provides functionality to sign an arbitrary message.

## Returns

* **data** (`Hex`): The signature generated.
* **error** (`Error | null`): An error object if the transaction failed, otherwise `null`.
* **isPending** (`boolean`): A boolean indicating whether the transaction is currently pending.
* **isSuccess** (`boolean`): A boolean indicating whether the transaction was successfully sent.
* **isError** (`boolean`): A boolean indicating whether an error occurred during the transaction process.
* **signMessage** : A function that signs a message and returns the signature.&#x20;
* **signMessageAsync** : A function that  signs a message and returns a promise that resolves to the signature.

## Example

```typescript
import { useSignMessage } from "@cometh/connect-react-hooks";

function MessageSigner() {
  const { signMessageAsync, isPending, isError, error, data } = useSignMessage();
 
  const handleSign = async () => {
    try {
      const signature = await signMessageAsync({ message: "Hello, World!" });
      console.log("Message signed:", signature);
    } catch (err) {
      console.error("Error signing message:", err);
    }
  };

  return (
    <div>
      <button onClick={handleSign} disabled={isPending}>
        Sign Message
      </button>
      {isPending && <p>Signing message...</p>}
      {isError && <p>Error: {error?.message}</p>}
      {data && <p>Signature: {data}</p>}
    </div>
  );
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.cometh.io/integrations/react-hooks/usesignmessage.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
